/*eslint-disable block-scoped-var, no-redeclare, no-control-regex, no-prototype-builtins*/
"use strict";

var $protobuf = require("protobufjs/light");

var $root = ($protobuf.roots["default"] = new $protobuf.Root())
.addJSON({
  matrix_io: {
    nested: {
      vision: {
        nested: {
          v1: {
            options: {
              csharp_namespace: "Matrix().Vision.V1",
              java_multiple_files: true,
              java_outer_classname: "VisionProto",
              java_package: "one.matrixio.proto.vision.v1"
            },
            nested: {
              VisionRequest: {
                fields: {
                  image: {
                    type: "bytes",
                    id: 1
                  },
                  detection: {
                    rule: "repeated",
                    type: "EnumDetectionTag",
                    id: 2
                  },
                  recognition: {
                    rule: "repeated",
                    type: "EnumFacialRecognitionTag",
                    id: 3
                  },
                  imageList: {
                    type: "ImageList",
                    id: 4
                  },
                  video: {
                    type: "Video",
                    id: 5
                  }
                }
              },
              VisionService: {
                methods: {
                  ProcessImage: {
                    requestType: "VisionRequest",
                    responseType: "VisionResult"
                  }
                }
              },
              Point: {
                fields: {
                  x: {
                    type: "float",
                    id: 1
                  },
                  y: {
                    type: "float",
                    id: 2
                  }
                }
              },
              Size: {
                fields: {
                  width: {
                    type: "int32",
                    id: 1
                  },
                  height: {
                    type: "int32",
                    id: 2
                  }
                }
              },
              Rectangle: {
                fields: {
                  x: {
                    type: "float",
                    id: 1
                  },
                  y: {
                    type: "float",
                    id: 2
                  },
                  width: {
                    type: "float",
                    id: 3
                  },
                  height: {
                    type: "float",
                    id: 4
                  }
                }
              },
              EnumFacialRecognitionTag: {
                values: {
                  AGE: 0,
                  EMOTION: 1,
                  GENDER: 2,
                  FACE_ID: 3,
                  HEAD_POSE: 4,
                  FACE_FEATURES: 5,
                  FACE_DESCRIPTOR: 6
                }
              },
              FacialRecognition: {
                fields: {
                  tag: {
                    type: "EnumFacialRecognitionTag",
                    id: 1
                  },
                  confidence: {
                    type: "float",
                    id: 2
                  },
                  age: {
                    type: "int32",
                    id: 3
                  },
                  gender: {
                    type: "Gender",
                    id: 4
                  },
                  emotion: {
                    type: "Emotion",
                    id: 5
                  },
                  faceDescriptor: {
                    rule: "repeated",
                    type: "float",
                    id: 6
                  },
                  faceId: {
                    type: "string",
                    id: 7
                  },
                  poseYaw: {
                    type: "float",
                    id: 8
                  },
                  poseRoll: {
                    type: "float",
                    id: 9
                  },
                  posePitch: {
                    type: "float",
                    id: 10
                  },
                  basicFeature: {
                    type: "BasicFaceFeature",
                    id: 11
                  }
                },
                nested: {
                  Gender: {
                    values: {
                      MALE: 0,
                      FEMALE: 1
                    }
                  },
                  Emotion: {
                    values: {
                      ANGRY: 0,
                      DISGUST: 1,
                      CONFUSED: 2,
                      HAPPY: 3,
                      SAD: 4,
                      SURPRISED: 5,
                      CALM: 6,
                      FEAR: 7,
                      NEUTRAL: 8
                    }
                  },
                  BasicFaceFeature: {
                    fields: {
                      mouth: {
                        rule: "repeated",
                        type: "Point",
                        id: 1
                      },
                      leftEye: {
                        rule: "repeated",
                        type: "Point",
                        id: 2
                      },
                      rightEye: {
                        rule: "repeated",
                        type: "Point",
                        id: 3
                      },
                      nose: {
                        rule: "repeated",
                        type: "Point",
                        id: 4
                      }
                    }
                  }
                }
              },
              ZoneDirection: {
                values: {
                  UNKNOWN: 0,
                  FORWARD: 1,
                  BACKWARD: 2
                }
              },
              ZoneConfig: {
                fields: {
                  name: {
                    type: "string",
                    id: 1
                  },
                  pointA: {
                    type: "Point",
                    id: 2
                  },
                  pointB: {
                    type: "Point",
                    id: 3
                  },
                  height: {
                    type: "int32",
                    id: 4
                  },
                  realHeight: {
                    type: "float",
                    id: 5
                  }
                }
              },
              AreaConfig: {
                fields: {
                  name: {
                    type: "string",
                    id: 1
                  },
                  point: {
                    rule: "repeated",
                    type: "Point",
                    id: 2
                  }
                }
              },
              AreaAndZoneConfig: {
                fields: {
                  area: {
                    rule: "repeated",
                    type: "AreaConfig",
                    id: 1
                  },
                  zone: {
                    rule: "repeated",
                    type: "ZoneConfig",
                    id: 2
                  },
                  regionOfInterest: {
                    rule: "repeated",
                    type: "Rectangle",
                    id: 3
                  }
                }
              },
              VehicleConfig: {
                fields: {
                  cameraUrl: {
                    type: "string",
                    id: 1
                  },
                  areaAndZone: {
                    type: "AreaAndZoneConfig",
                    id: 2
                  }
                }
              },
              EventTag: {
                values: {
                  TRACKING_START: 0,
                  TRACKING_END: 1,
                  AREA_ENTER: 2,
                  AREA_EXIT: 3,
                  ZONE_ENTER: 4,
                  ZONE_EXIT: 5
                }
              },
              VisionEvent: {
                fields: {
                  tag: {
                    type: "EventTag",
                    id: 1
                  },
                  trackingId: {
                    type: "uint64",
                    id: 2
                  },
                  sessionTime: {
                    type: "float",
                    id: 3
                  },
                  dwellTime: {
                    type: "float",
                    id: 4
                  },
                  areaId: {
                    type: "uint64",
                    id: 5
                  },
                  zoneId: {
                    type: "uint64",
                    id: 6
                  },
                  zoneDirection: {
                    type: "ZoneDirection",
                    id: 7
                  },
                  speed: {
                    type: "float",
                    id: 8
                  },
                  timestamp: {
                    type: "google.protobuf.Timestamp",
                    id: 9
                  }
                }
              },
              EnumDetectionTag: {
                values: {
                  FACE: 0,
                  HAND_THUMB: 1,
                  HAND_PALM: 2,
                  HAND_PINCH: 3,
                  HAND_FIST: 4,
                  PERSON: 5
                }
              },
              EnumDetectionAlgorithm: {
                values: {
                  DEFAULT: 0,
                  FIRST_ALTERNATIVE: 1
                }
              },
              VehicleRecognition: {
                fields: {
                  type: {
                    type: "string",
                    id: 1
                  },
                  brand: {
                    type: "string",
                    id: 2
                  },
                  model: {
                    type: "string",
                    id: 3
                  },
                  year: {
                    type: "int32",
                    id: 4
                  }
                }
              },
              RectangularDetection: {
                fields: {
                  algorithm: {
                    type: "EnumDetectionAlgorithm",
                    id: 1
                  },
                  location: {
                    type: "Rectangle",
                    id: 2
                  },
                  tag: {
                    type: "EnumDetectionTag",
                    id: 3
                  },
                  confidence: {
                    type: "float",
                    id: 4
                  },
                  facialRecognition: {
                    rule: "repeated",
                    type: "FacialRecognition",
                    id: 5
                  },
                  vehicleRecognition: {
                    rule: "repeated",
                    type: "VehicleRecognition",
                    id: 9
                  },
                  speed: {
                    type: "float",
                    id: 10
                  },
                  image: {
                    type: "bytes",
                    id: 6
                  },
                  imageSmall: {
                    type: "bytes",
                    id: 7
                  },
                  trackingId: {
                    type: "uint64",
                    id: 8
                  },
                  uuid: {
                    type: "string",
                    id: 11
                  }
                }
              },
              ImageList: {
                fields: {
                  imageData: {
                    rule: "repeated",
                    type: "bytes",
                    id: 1
                  },
                  framesPerSecond: {
                    type: "int32",
                    id: 2
                  }
                }
              },
              EnumVideoCodec: {
                values: {
                  UNDEFINED_VIDEO_CODEC: 0,
                  H264: 1,
                  MP4V: 2,
                  RV24: 3,
                  VP8: 4,
                  VP9: 5
                }
              },
              Video: {
                fields: {
                  videoData: {
                    type: "bytes",
                    id: 1
                  },
                  codec: {
                    type: "EnumVideoCodec",
                    id: 2
                  },
                  tag: {
                    rule: "repeated",
                    type: "string",
                    id: 3
                  }
                }
              },
              ImageFormat: {
                values: {
                  UNSPECIFIED: 0,
                  FORMAT_8URGB: 1,
                  FORMAT_8UBGR: 2,
                  FORMAT_8U: 3
                }
              },
              Image: {
                fields: {
                  image: {
                    type: "bytes",
                    id: 1
                  },
                  format: {
                    type: "ImageFormat",
                    id: 2
                  },
                  size: {
                    type: "Size",
                    id: 3
                  }
                }
              },
              VisionResult: {
                fields: {
                  rectDetection: {
                    rule: "repeated",
                    type: "RectangularDetection",
                    id: 1
                  },
                  visionEvent: {
                    rule: "repeated",
                    type: "VisionEvent",
                    id: 4
                  },
                  resultImage: {
                    type: "Image",
                    id: 5
                  },
                  resultImageSmall: {
                    type: "Image",
                    id: 6
                  },
                  image: {
                    type: "bytes",
                    id: 2
                  },
                  imageSmall: {
                    type: "bytes",
                    id: 3
                  }
                }
              }
            }
          }
        }
      },
      recognition: {
        nested: {
          v1: {
            options: {
              csharp_namespace: "MatrixIO.Recognition.V1",
              java_multiple_files: true,
              java_outer_classname: "RecognitionProto",
              java_package: "one.matrixio.proto.recognition.v1"
            },
            nested: {
              RecognitionService: {
                methods: {
                  StoreFeatureDescriptors: {
                    requestType: "StoreFeatureDescriptorsRequest",
                    responseType: "StoreFeatureDescriptorsResponse"
                  },
                  GetFeatureDescriptors: {
                    requestType: "GetFeatureDescriptorsRequest",
                    responseType: "GetFeatureDescriptorsResponse"
                  },
                  DeleteFeatureDescriptors: {
                    requestType: "DeleteFeatureDescriptorsRequest",
                    responseType: "DeleteFeatureDescriptorsResponse"
                  },
                  GetFeatureDescriptorTags: {
                    requestType: "GetFeatureDescriptorTagsRequest",
                    responseType: "GetFeatureDescriptorTagsResponse"
                  },
                  Recognize: {
                    requestType: "RecognizeRequest",
                    responseType: "RecognizeResponse"
                  }
                }
              },
              StoreFeatureDescriptorsRequest: {
                fields: {
                  visionRequest: {
                    type: "matrix_io.vision.v1.VisionRequest",
                    id: 1
                  },
                  tags: {
                    rule: "repeated",
                    type: "string",
                    id: 2
                  },
                  featureDescriptors: {
                    rule: "repeated",
                    type: "FeatureDescriptor",
                    id: 3
                  },
                  deviceId: {
                    rule: "repeated",
                    type: "string",
                    id: 4
                  }
                }
              },
              StoreFeatureDescriptorsResponse: {
                fields: {
                  uuids: {
                    rule: "repeated",
                    type: "string",
                    id: 1
                  }
                }
              },
              GetFeatureDescriptorsRequest: {
                fields: {
                  uuids: {
                    rule: "repeated",
                    type: "string",
                    id: 1
                  },
                  tags: {
                    rule: "repeated",
                    type: "string",
                    id: 2
                  },
                  deviceId: {
                    type: "string",
                    id: 3
                  },
                  nextPageToken: {
                    type: "string",
                    id: 4
                  }
                }
              },
              GetFeatureDescriptorsResponse: {
                fields: {
                  featureDescriptorList: {
                    type: "FeatureDescriptorList",
                    id: 1
                  },
                  nextPageToken: {
                    type: "string",
                    id: 2
                  }
                }
              },
              DeleteFeatureDescriptorsRequest: {
                fields: {
                  uuids: {
                    rule: "repeated",
                    type: "string",
                    id: 1
                  },
                  tags: {
                    rule: "repeated",
                    type: "string",
                    id: 2
                  }
                }
              },
              DeleteFeatureDescriptorsResponse: {
                fields: {
                  uuids: {
                    rule: "repeated",
                    type: "string",
                    id: 1
                  }
                }
              },
              RecognizeRequest: {
                fields: {
                  visionRequest: {
                    type: "matrix_io.vision.v1.VisionRequest",
                    id: 1
                  },
                  featureDescriptorList: {
                    type: "FeatureDescriptorList",
                    id: 2
                  },
                  matchingAlgorithmVersion: {
                    type: "string",
                    id: 3
                  }
                }
              },
              FeatureDescriptorMatch: {
                fields: {
                  tags: {
                    rule: "repeated",
                    type: "string",
                    id: 1
                  },
                  score: {
                    type: "float",
                    id: 2
                  }
                }
              },
              RecognizeResponse: {
                fields: {
                  matches: {
                    rule: "repeated",
                    type: "FeatureDescriptorMatch",
                    id: 1
                  }
                }
              },
              GetFeatureDescriptorTagsRequest: {
                fields: {
                  deviceId: {
                    rule: "repeated",
                    type: "string",
                    id: 1
                  }
                }
              },
              FeatureDescriptorTagsForDevice: {
                fields: {
                  tags: {
                    rule: "repeated",
                    type: "string",
                    id: 1
                  },
                  deviceId: {
                    type: "string",
                    id: 2
                  }
                }
              },
              GetFeatureDescriptorTagsResponse: {
                fields: {
                  featureTagsForDevice: {
                    rule: "repeated",
                    type: "FeatureDescriptorTagsForDevice",
                    id: 1
                  }
                }
              },
              FeatureDescriptor: {
                fields: {
                  uuid: {
                    type: "string",
                    id: 1
                  },
                  dataFormat: {
                    type: "string",
                    id: 2
                  },
                  data: {
                    rule: "repeated",
                    type: "float",
                    id: 3
                  },
                  tags: {
                    rule: "repeated",
                    type: "string",
                    id: 4
                  }
                }
              },
              FeatureDescriptorList: {
                fields: {
                  featureDescriptors: {
                    rule: "repeated",
                    type: "FeatureDescriptor",
                    id: 1
                  }
                }
              }
            }
          }
        }
      },
      malos: {
        nested: {
          v1: {
            nested: {
              io: {
                options: {
                  csharp_namespace: "MatrixIO.Malos.IO.V1",
                  java_multiple_files: true,
                  java_outer_classname: "IOProto",
                  java_package: "one.matrixio.proto.malos.v1"
                },
                nested: {
                  LedValue: {
                    fields: {
                      red: {
                        type: "uint32",
                        id: 1
                      },
                      green: {
                        type: "uint32",
                        id: 2
                      },
                      blue: {
                        type: "uint32",
                        id: 3
                      },
                      white: {
                        type: "uint32",
                        id: 4
                      }
                    }
                  },
                  EverloopImage: {
                    fields: {
                      led: {
                        rule: "repeated",
                        type: "LedValue",
                        id: 1
                      }
                    }
                  },
                  ServoParams: {
                    fields: {
                      pin: {
                        type: "uint32",
                        id: 1
                      },
                      angle: {
                        type: "uint32",
                        id: 2
                      }
                    }
                  },
                  GpioParams: {
                    fields: {
                      pin: {
                        type: "uint32",
                        id: 1
                      },
                      mode: {
                        type: "EnumMode",
                        id: 2
                      },
                      value: {
                        type: "uint32",
                        id: 3
                      },
                      values: {
                        type: "uint32",
                        id: 4
                      }
                    },
                    nested: {
                      EnumMode: {
                        values: {
                          INPUT: 0,
                          OUTPUT: 1
                        }
                      }
                    }
                  },
                  MicArrayParams: {
                    fields: {
                      gain: {
                        type: "int32",
                        id: 1
                      },
                      azimutalAngle: {
                        type: "float",
                        id: 2
                      },
                      polarAngle: {
                        type: "float",
                        id: 3
                      },
                      radialDistanceMm: {
                        type: "float",
                        id: 4
                      },
                      soundSpeedMmseg: {
                        type: "float",
                        id: 5
                      },
                      samplingFrequencyHz: {
                        type: "uint32",
                        id: 6
                      }
                    }
                  },
                  WakeWordParams: {
                    fields: {
                      wakeWord: {
                        type: "string",
                        id: 1
                      },
                      channel: {
                        type: "MicChannel",
                        id: 2
                      },
                      lmPath: {
                        type: "string",
                        id: 3
                      },
                      dicPath: {
                        type: "string",
                        id: 4
                      },
                      enableVerbose: {
                        type: "bool",
                        id: 5
                      },
                      stopRecognition: {
                        type: "bool",
                        id: 6
                      }
                    },
                    nested: {
                      MicChannel: {
                        values: {
                          channel0: 0,
                          channel1: 1,
                          channel2: 2,
                          channel3: 3,
                          channel4: 4,
                          channel5: 5,
                          channel6: 6,
                          channel7: 7,
                          channel8: 8
                        }
                      }
                    }
                  }
                }
              },
              comm: {
                options: {
                  csharp_namespace: "MatrixIO.Malos.Comm.V1",
                  java_multiple_files: true,
                  java_outer_classname: "CommProto",
                  java_package: "one.matrixio.proto.malos.v1"
                },
                nested: {
                  ZWaveClassType: {
                    options: {
                      allow_alias: true
                    },
                    values: {
                      COMMAND_CLASS_NO_OPERATION: 0,
                      ZWAVE_CMD_CLASS: 1,
                      COMMAND_CLASS_ZENSOR_NET: 2,
                      COMMAND_CLASS_BASIC: 32,
                      COMMAND_CLASS_CONTROLLER_REPLICATION: 33,
                      COMMAND_CLASS_APPLICATION_STATUS: 34,
                      COMMAND_CLASS_ZIP: 35,
                      COMMAND_CLASS_SECURITY_PANEL_MODE: 36,
                      COMMAND_CLASS_SWITCH_BINARY: 37,
                      COMMAND_CLASS_SWITCH_MULTILEVEL: 38,
                      COMMAND_CLASS_SWITCH_ALL: 39,
                      COMMAND_CLASS_SWITCH_TOGGLE_BINARY: 40,
                      COMMAND_CLASS_SWITCH_TOGGLE_MULTILEVEL: 41,
                      COMMAND_CLASS_CHIMNEY_FAN: 42,
                      COMMAND_CLASS_SCENE_ACTIVATION: 43,
                      COMMAND_CLASS_SCENE_ACTUATOR_CONF: 44,
                      COMMAND_CLASS_SCENE_CONTROLLER_CONF: 45,
                      COMMAND_CLASS_SECURITY_PANEL_ZONE: 46,
                      COMMAND_CLASS_SECURITY_PANEL_ZONE_SENSOR: 47,
                      COMMAND_CLASS_SENSOR_BINARY: 48,
                      COMMAND_CLASS_SENSOR_MULTILEVEL: 49,
                      COMMAND_CLASS_METER: 50,
                      COMMAND_CLASS_SWITCH_COLOR: 51,
                      COMMAND_CLASS_NETWORK_MANAGEMENT_INCLUSION: 52,
                      COMMAND_CLASS_METER_PULSE: 53,
                      COMMAND_CLASS_BASIC_TARIFF_INFO: 54,
                      COMMAND_CLASS_HRV_STATUS: 55,
                      COMMAND_CLASS_THERMOSTAT_HEATING: 56,
                      COMMAND_CLASS_HRV_CONTROL: 57,
                      COMMAND_CLASS_DCP_CONFIG: 58,
                      COMMAND_CLASS_DCP_MONITOR: 59,
                      COMMAND_CLASS_METER_TBL_CONFIG: 60,
                      COMMAND_CLASS_METER_TBL_MONITOR: 61,
                      COMMAND_CLASS_METER_TBL_PUSH: 62,
                      COMMAND_CLASS_PREPAYMENT: 63,
                      COMMAND_CLASS_THERMOSTAT_MODE: 64,
                      COMMAND_CLASS_PREPAYMENT_ENCAPSULATION: 65,
                      COMMAND_CLASS_THERMOSTAT_OPERATING_STATE: 66,
                      COMMAND_CLASS_THERMOSTAT_SETPOINT: 67,
                      COMMAND_CLASS_THERMOSTAT_FAN_MODE: 68,
                      COMMAND_CLASS_THERMOSTAT_FAN_STATE: 69,
                      COMMAND_CLASS_CLIMATE_CONTROL_SCHEDULE: 70,
                      COMMAND_CLASS_THERMOSTAT_SETBACK: 71,
                      COMMAND_CLASS_RATE_TBL_CONFIG: 72,
                      COMMAND_CLASS_RATE_TBL_MONITOR: 73,
                      COMMAND_CLASS_TARIFF_CONFIG: 74,
                      COMMAND_CLASS_TARIFF_TBL_MONITOR: 75,
                      COMMAND_CLASS_DOOR_LOCK_LOGGING: 76,
                      COMMAND_CLASS_NETWORK_MANAGEMENT_BASIC: 77,
                      COMMAND_CLASS_SCHEDULE_ENTRY_LOCK: 78,
                      COMMAND_CLASS_ZIP_6LOWPAN: 79,
                      COMMAND_CLASS_BASIC_WINDOW_COVERING: 80,
                      COMMAND_CLASS_MTP_WINDOW_COVERING: 81,
                      COMMAND_CLASS_NETWORK_MANAGEMENT_PROXY: 82,
                      COMMAND_CLASS_SCHEDULE: 83,
                      COMMAND_CLASS_NETWORK_MANAGEMENT_PRIMARY: 84,
                      COMMAND_CLASS_TRANSPORT_SERVICE: 85,
                      COMMAND_CLASS_CRC_16_ENCAP: 86,
                      COMMAND_CLASS_APPLICATION_CAPABILITY: 87,
                      COMMAND_CLASS_ZIP_ND: 88,
                      COMMAND_CLASS_ASSOCIATION_GRP_INFO: 89,
                      COMMAND_CLASS_DEVICE_RESET_LOCALLY: 90,
                      COMMAND_CLASS_CENTRAL_SCENE: 91,
                      COMMAND_CLASS_IP_ASSOCIATION: 92,
                      COMMAND_CLASS_ANTITHEFT: 93,
                      COMMAND_CLASS_ZWAVEPLUS_INFO: 94,
                      COMMAND_CLASS_ZIP_GATEWAY: 95,
                      COMMAND_CLASS_MULTI_CHANNEL: 96,
                      COMMAND_CLASS_MULTI_INSTANCE: 96,
                      COMMAND_CLASS_ZIP_PORTAL: 97,
                      COMMAND_CLASS_DOOR_LOCK: 98,
                      COMMAND_CLASS_USER_CODE: 99,
                      COMMAND_CLASS_HUMIDITY_CONTROL_SETPOINT: 100,
                      COMMAND_CLASS_DMX: 101,
                      COMMAND_CLASS_BARRIER_OPERATOR: 102,
                      COMMAND_CLASS_NETWORK_MANAGEMENT_INSTALLATION_MAINTENANCE: 103,
                      COMMAND_CLASS_ZIP_NAMING: 104,
                      COMMAND_CLASS_MAILBOX: 105,
                      COMMAND_CLASS_WINDOW_COVERING: 106,
                      COMMAND_CLASS_IRRIGATION: 107,
                      COMMAND_CLASS_SUPERVISION: 108,
                      COMMAND_CLASS_HUMIDITY_CONTROL_MODE: 109,
                      COMMAND_CLASS_HUMIDITY_CONTROL_OPERATING_STATE: 110,
                      COMMAND_CLASS_ENTRY_CONTROL: 111,
                      COMMAND_CLASS_CONFIGURATION: 112,
                      COMMAND_CLASS_ALARM: 113,
                      COMMAND_CLASS_NOTIFICATION: 113,
                      COMMAND_CLASS_MANUFACTURER_SPECIFIC: 114,
                      COMMAND_CLASS_POWERLEVEL: 115,
                      COMMAND_CLASS_INCLUSION_CONTROLLER: 116,
                      COMMAND_CLASS_PROTECTION: 117,
                      COMMAND_CLASS_LOCK: 118,
                      COMMAND_CLASS_NODE_NAMING: 119,
                      COMMAND_CLASS_FIRMWARE_UPDATE_MD: 122,
                      COMMAND_CLASS_GROUPING_NAME: 123,
                      COMMAND_CLASS_REMOTE_ASSOCIATION_ACTIVATE: 124,
                      COMMAND_CLASS_REMOTE_ASSOCIATION: 125,
                      COMMAND_CLASS_BATTERY: 128,
                      COMMAND_CLASS_CLOCK: 129,
                      COMMAND_CLASS_HAIL: 130,
                      COMMAND_CLASS_WAKE_UP: 132,
                      COMMAND_CLASS_ASSOCIATION: 133,
                      COMMAND_CLASS_VERSION: 134,
                      COMMAND_CLASS_INDICATOR: 135,
                      COMMAND_CLASS_PROPRIETARY: 136,
                      COMMAND_CLASS_LANGUAGE: 137,
                      COMMAND_CLASS_TIME: 138,
                      COMMAND_CLASS_TIME_PARAMETERS: 139,
                      COMMAND_CLASS_GEOGRAPHIC_LOCATION: 140,
                      COMMAND_CLASS_MULTI_CHANNEL_ASSOCIATION: 142,
                      COMMAND_CLASS_MULTI_INSTANCE_ASSOCIATION: 142,
                      COMMAND_CLASS_MULTI_CMD: 143,
                      COMMAND_CLASS_ENERGY_PRODUCTION: 144,
                      COMMAND_CLASS_MANUFACTURER_PROPRIETARY: 145,
                      COMMAND_CLASS_SCREEN_MD: 146,
                      COMMAND_CLASS_SCREEN_ATTRIBUTES: 147,
                      COMMAND_CLASS_SIMPLE_AV_CONTROL: 148,
                      COMMAND_CLASS_AV_CONTENT_DIRECTORY_MD: 149,
                      COMMAND_CLASS_AV_RENDERER_STATUS: 150,
                      COMMAND_CLASS_AV_CONTENT_SEARCH_MD: 151,
                      COMMAND_CLASS_SECURITY: 152,
                      COMMAND_CLASS_AV_TAGGING_MD: 153,
                      COMMAND_CLASS_IP_CONFIGURATION: 154,
                      COMMAND_CLASS_ASSOCIATION_COMMAND_CONFIGURATION: 155,
                      COMMAND_CLASS_SENSOR_ALARM: 156,
                      COMMAND_CLASS_SILENCE_ALARM: 157,
                      COMMAND_CLASS_SENSOR_CONFIGURATION: 158,
                      COMMAND_CLASS_SECURITY_2: 159,
                      COMMAND_CLASS_MARK: 239,
                      COMMAND_CLASS_NON_INTEROPERABLE: 240
                    }
                  },
                  ZWaveCmdType: {
                    values: {
                      CMD_UNDEFINED: 0,
                      ACCEPT_LOST: 1,
                      ALARM_GET: 2,
                      ALARM_REPORT: 3,
                      ANTITHEFT_GET: 4,
                      ANTITHEFT_REPORT: 5,
                      ANTITHEFT_SET: 6,
                      APPLICATION_BUSY: 7,
                      APPLICATION_REJECTED_REQUEST: 8,
                      ASSIGN_ID: 9,
                      ASSIGN_RETURN_ROUTE: 10,
                      ASSIGN_RETURN_ROUTE_PRIORITY: 11,
                      ASSIGN_SUC_RETURN_ROUTE_PRIORITY: 12,
                      ASSOCIATION_GET: 13,
                      ASSOCIATION_GROUPINGS_GET: 14,
                      ASSOCIATION_GROUPINGS_REPORT: 15,
                      ASSOCIATION_GROUP_COMMAND_LIST_GET: 16,
                      ASSOCIATION_GROUP_COMMAND_LIST_REPORT: 17,
                      ASSOCIATION_GROUP_INFO_GET: 18,
                      ASSOCIATION_GROUP_INFO_REPORT: 19,
                      ASSOCIATION_GROUP_NAME_GET: 20,
                      ASSOCIATION_GROUP_NAME_REPORT: 21,
                      ASSOCIATION_REMOVE: 22,
                      ASSOCIATION_REPORT: 23,
                      ASSOCIATION_SET: 24,
                      AV_CONTENT_BROWSE_MD_BY_LETTER_GET: 25,
                      AV_CONTENT_BROWSE_MD_BY_LETTER_REPORT: 26,
                      AV_CONTENT_BROWSE_MD_CHILD_COUNT_GET: 27,
                      AV_CONTENT_BROWSE_MD_CHILD_COUNT_REPORT: 28,
                      AV_CONTENT_BROWSE_MD_GET: 29,
                      AV_CONTENT_BROWSE_MD_REPORT: 30,
                      AV_CONTENT_SEARCH_MD_GET: 31,
                      AV_CONTENT_SEARCH_MD_REPORT: 32,
                      AV_MATCH_ITEM_TO_RENDERER_MD_GET: 33,
                      AV_MATCH_ITEM_TO_RENDERER_MD_REPORT: 34,
                      AV_RENDERER_STATUS_GET: 35,
                      AV_RENDERER_STATUS_REPORT: 36,
                      AV_TAGGING_MD_GET: 37,
                      AV_TAGGING_MD_REPORT: 38,
                      BARRIER_OPERATOR_GET: 39,
                      BARRIER_OPERATOR_REPORT: 40,
                      BARRIER_OPERATOR_SET: 41,
                      BARRIER_OPERATOR_SIGNAL_GET: 42,
                      BARRIER_OPERATOR_SIGNAL_REPORT: 43,
                      BARRIER_OPERATOR_SIGNAL_SET: 44,
                      BARRIER_OPERATOR_SIGNAL_SUPPORTED_GET: 45,
                      BARRIER_OPERATOR_SIGNAL_SUPPORTED_REPORT: 46,
                      BASIC_GET: 47,
                      BASIC_REPORT: 48,
                      BASIC_SET: 49,
                      BASIC_TARIFF_INFO_GET: 50,
                      BASIC_TARIFF_INFO_REPORT: 51,
                      BASIC_WINDOW_COVERING_START_LEVEL_CHANGE: 52,
                      BASIC_WINDOW_COVERING_STOP_LEVEL_CHANGE: 53,
                      BATTERY_GET: 54,
                      BATTERY_REPORT: 55,
                      BIND_ACCEPT: 56,
                      BIND_COMPLETE: 57,
                      BIND_REQUEST: 58,
                      CENTRAL_SCENE_NOTIFICATION: 59,
                      CENTRAL_SCENE_SUPPORTED_GET: 60,
                      CENTRAL_SCENE_SUPPORTED_REPORT: 61,
                      CHIMNEY_FAN_ALARM_LOG_GET: 62,
                      CHIMNEY_FAN_ALARM_LOG_REPORT: 63,
                      CHIMNEY_FAN_ALARM_LOG_SET: 64,
                      CHIMNEY_FAN_ALARM_STATUS_GET: 65,
                      CHIMNEY_FAN_ALARM_STATUS_REPORT: 66,
                      CHIMNEY_FAN_ALARM_STATUS_SET: 67,
                      CHIMNEY_FAN_ALARM_TEMP_GET: 68,
                      CHIMNEY_FAN_ALARM_TEMP_REPORT: 69,
                      CHIMNEY_FAN_ALARM_TEMP_SET: 70,
                      CHIMNEY_FAN_BOOST_TIME_GET: 71,
                      CHIMNEY_FAN_BOOST_TIME_REPORT: 72,
                      CHIMNEY_FAN_BOOST_TIME_SET: 73,
                      CHIMNEY_FAN_DEFAULT_SET: 74,
                      CHIMNEY_FAN_MIN_SPEED_GET: 75,
                      CHIMNEY_FAN_MIN_SPEED_REPORT: 76,
                      CHIMNEY_FAN_MIN_SPEED_SET: 77,
                      CHIMNEY_FAN_MODE_GET: 78,
                      CHIMNEY_FAN_MODE_REPORT: 79,
                      CHIMNEY_FAN_MODE_SET: 80,
                      CHIMNEY_FAN_SETUP_GET: 81,
                      CHIMNEY_FAN_SETUP_REPORT: 82,
                      CHIMNEY_FAN_SETUP_SET: 83,
                      CHIMNEY_FAN_SPEED_GET: 84,
                      CHIMNEY_FAN_SPEED_REPORT: 85,
                      CHIMNEY_FAN_SPEED_SET: 86,
                      CHIMNEY_FAN_START_TEMP_GET: 87,
                      CHIMNEY_FAN_START_TEMP_REPORT: 88,
                      CHIMNEY_FAN_START_TEMP_SET: 89,
                      CHIMNEY_FAN_STATE_GET: 90,
                      CHIMNEY_FAN_STATE_REPORT: 91,
                      CHIMNEY_FAN_STATE_SET: 92,
                      CHIMNEY_FAN_STATUS_GET: 93,
                      CHIMNEY_FAN_STATUS_REPORT: 94,
                      CHIMNEY_FAN_STOP_TEMP_GET: 95,
                      CHIMNEY_FAN_STOP_TEMP_REPORT: 96,
                      CHIMNEY_FAN_STOP_TEMP_SET: 97,
                      CHIMNEY_FAN_STOP_TIME_GET: 98,
                      CHIMNEY_FAN_STOP_TIME_REPORT: 99,
                      CHIMNEY_FAN_STOP_TIME_SET: 100,
                      CLOCK_GET: 101,
                      CLOCK_REPORT: 102,
                      CLOCK_SET: 103,
                      CMD_ASSIGN_SUC_RETURN_ROUTE: 104,
                      CMD_AUTOMATIC_CONTROLLER_UPDATE_START: 105,
                      CMD_ENCAPSULATION: 106,
                      CMD_NODES_EXIST: 107,
                      CMD_NODES_EXIST_REPLY: 108,
                      CMD_NOP_POWER: 109,
                      CMD_RESERVED_IDS: 110,
                      CMD_SET_NWI_MODE: 111,
                      CMD_SET_SUC: 112,
                      CMD_SET_SUC_ACK: 113,
                      CMD_STATIC_ROUTE_REQUEST: 114,
                      CMD_SUC_NODE_ID: 115,
                      COMMAND_APPLICATION_NODE_INFO_GET: 116,
                      COMMAND_APPLICATION_NODE_INFO_REPORT: 117,
                      COMMAND_APPLICATION_NODE_INFO_SET: 118,
                      COMMAND_CLASS_SECURITY_PANEL_ZONE_SENSOR_INSTALLED_REPORT: 119,
                      COMMAND_COMMAND_CLASS_NOT_SUPPORTED: 120,
                      COMMAND_COMPLETE: 121,
                      COMMAND_CONFIGURATION_GET: 122,
                      COMMAND_CONFIGURATION_REPORT: 123,
                      COMMAND_CONFIGURATION_SET: 124,
                      COMMAND_FIRST_SEGMENT: 125,
                      COMMAND_RECORDS_SUPPORTED_GET: 126,
                      COMMAND_RECORDS_SUPPORTED_REPORT: 127,
                      COMMAND_SCHEDULE_GET: 128,
                      COMMAND_SCHEDULE_REPORT: 129,
                      COMMAND_SCHEDULE_SET: 130,
                      COMMAND_SEGMENT_COMPLETE: 131,
                      COMMAND_SEGMENT_REQUEST: 132,
                      COMMAND_SEGMENT_WAIT: 133,
                      COMMAND_SUBSEQUENT_SEGMENT: 134,
                      COMMAND_ZIP_PACKET: 135,
                      COMPLETE: 136,
                      CONFIGURATION_GET: 137,
                      CONFIGURATION_REPORT: 138,
                      CONFIGURATION_SET: 139,
                      CONTROLLER_CHANGE: 140,
                      CONTROLLER_CHANGE_STATUS: 141,
                      CRC_16_ENCAP: 142,
                      CTRL_REPLICATION_TRANSFER_GROUP: 143,
                      CTRL_REPLICATION_TRANSFER_GROUP_NAME: 144,
                      CTRL_REPLICATION_TRANSFER_SCENE: 145,
                      CTRL_REPLICATION_TRANSFER_SCENE_NAME: 146,
                      DATE_GET: 147,
                      DATE_REPORT: 148,
                      DCP_EVENT_STATUS_GET: 149,
                      DCP_EVENT_STATUS_REPORT: 150,
                      DCP_LIST_GET: 151,
                      DCP_LIST_REMOVE: 152,
                      DCP_LIST_REPORT: 153,
                      DCP_LIST_SET: 154,
                      DCP_LIST_SUPPORTED_GET: 155,
                      DCP_LIST_SUPPORTED_REPORT: 156,
                      DEFAULT_SET: 157,
                      DEFAULT_SET_COMPLETE: 158,
                      DEVICE_RESET_LOCALLY_NOTIFICATION: 159,
                      DMX_ADDRESS_GET: 160,
                      DMX_ADDRESS_REPORT: 161,
                      DMX_ADDRESS_SET: 162,
                      DMX_CAPABILITY_GET: 163,
                      DMX_CAPABILITY_REPORT: 164,
                      DMX_DATA: 165,
                      DOOR_LOCK_CONFIGURATION_GET: 166,
                      DOOR_LOCK_CONFIGURATION_REPORT: 167,
                      DOOR_LOCK_CONFIGURATION_SET: 168,
                      DOOR_LOCK_LOGGING_RECORDS_SUPPORTED_GET: 169,
                      DOOR_LOCK_LOGGING_RECORDS_SUPPORTED_REPORT: 170,
                      DOOR_LOCK_OPERATION_GET: 171,
                      DOOR_LOCK_OPERATION_REPORT: 172,
                      DOOR_LOCK_OPERATION_SET: 173,
                      ENERGY_PRODUCTION_GET: 174,
                      ENERGY_PRODUCTION_REPORT: 175,
                      ENTRY_CONTROL_CONFIGURATION_GET: 176,
                      ENTRY_CONTROL_CONFIGURATION_REPORT: 177,
                      ENTRY_CONTROL_CONFIGURATION_SET: 178,
                      ENTRY_CONTROL_EVENT_SUPPORTED_GET: 179,
                      ENTRY_CONTROL_EVENT_SUPPORTED_REPORT: 180,
                      ENTRY_CONTROL_KEY_SUPPORTED_GET: 181,
                      ENTRY_CONTROL_KEY_SUPPORTED_REPORT: 182,
                      ENTRY_CONTROL_NOTIFICATION: 183,
                      EVENT_SUPPORTED_GET: 184,
                      EVENT_SUPPORTED_REPORT: 185,
                      EXCLUDE_REQUEST: 186,
                      FAILED_NODE_REMOVE: 187,
                      FAILED_NODE_REMOVE_STATUS: 188,
                      FAILED_NODE_REPLACE: 189,
                      FAILED_NODE_REPLACE_STATUS: 190,
                      FIND_NODES_IN_RANGE: 191,
                      FIRMWARE_MD_GET: 192,
                      FIRMWARE_MD_REPORT: 193,
                      FIRMWARE_UPDATE_MD_GET: 194,
                      FIRMWARE_UPDATE_MD_REPORT: 195,
                      FIRMWARE_UPDATE_MD_REQUEST_GET: 196,
                      FIRMWARE_UPDATE_MD_REQUEST_REPORT: 197,
                      FIRMWARE_UPDATE_MD_STATUS_REPORT: 198,
                      GATEWAY_CONFIGURATION_GET: 199,
                      GATEWAY_CONFIGURATION_REPORT: 200,
                      GATEWAY_CONFIGURATION_SET: 201,
                      GATEWAY_CONFIGURATION_STATUS: 202,
                      GATEWAY_LOCK_SET: 203,
                      GATEWAY_MODE_GET: 204,
                      GATEWAY_MODE_REPORT: 205,
                      GATEWAY_MODE_SET: 206,
                      GATEWAY_PEER_GET: 207,
                      GATEWAY_PEER_REPORT: 208,
                      GATEWAY_PEER_SET: 209,
                      GEOGRAPHIC_LOCATION_GET: 210,
                      GEOGRAPHIC_LOCATION_REPORT: 211,
                      GEOGRAPHIC_LOCATION_SET: 212,
                      GET_NODES_IN_RANGE: 213,
                      GROUPING_NAME_GET: 214,
                      GROUPING_NAME_REPORT: 215,
                      GROUPING_NAME_SET: 216,
                      HAIL: 217,
                      HRV_CONTROL_BYPASS_GET: 218,
                      HRV_CONTROL_BYPASS_REPORT: 219,
                      HRV_CONTROL_BYPASS_SET: 220,
                      HRV_CONTROL_MODE_GET: 221,
                      HRV_CONTROL_MODE_REPORT: 222,
                      HRV_CONTROL_MODE_SET: 223,
                      HRV_CONTROL_MODE_SUPPORTED_GET: 224,
                      HRV_CONTROL_MODE_SUPPORTED_REPORT: 225,
                      HRV_CONTROL_VENTILATION_RATE_GET: 226,
                      HRV_CONTROL_VENTILATION_RATE_REPORT: 227,
                      HRV_CONTROL_VENTILATION_RATE_SET: 228,
                      HRV_STATUS_GET: 229,
                      HRV_STATUS_REPORT: 230,
                      HRV_STATUS_SUPPORTED_GET: 231,
                      HRV_STATUS_SUPPORTED_REPORT: 232,
                      HUMIDITY_CONTROL_MODE_GET: 233,
                      HUMIDITY_CONTROL_MODE_REPORT: 234,
                      HUMIDITY_CONTROL_MODE_SET: 235,
                      HUMIDITY_CONTROL_MODE_SUPPORTED_GET: 236,
                      HUMIDITY_CONTROL_MODE_SUPPORTED_REPORT: 237,
                      HUMIDITY_CONTROL_OPERATING_STATE_GET: 238,
                      HUMIDITY_CONTROL_OPERATING_STATE_REPORT: 239,
                      HUMIDITY_CONTROL_SETPOINT_CAPABILITIES_GET: 240,
                      HUMIDITY_CONTROL_SETPOINT_CAPABILITIES_REPORT: 241,
                      HUMIDITY_CONTROL_SETPOINT_GET: 242,
                      HUMIDITY_CONTROL_SETPOINT_REPORT: 243,
                      HUMIDITY_CONTROL_SETPOINT_SCALE_SUPPORTED_GET: 244,
                      HUMIDITY_CONTROL_SETPOINT_SCALE_SUPPORTED_REPORT: 245,
                      HUMIDITY_CONTROL_SETPOINT_SET: 246,
                      HUMIDITY_CONTROL_SETPOINT_SUPPORTED_GET: 247,
                      HUMIDITY_CONTROL_SETPOINT_SUPPORTED_REPORT: 248,
                      INDICATOR_GET: 249,
                      INDICATOR_REPORT: 250,
                      INDICATOR_SET: 251,
                      INITIATE: 252,
                      IP_ASSOCIATION_GET: 253,
                      IP_ASSOCIATION_REMOVE: 254,
                      IP_ASSOCIATION_REPORT: 255,
                      IP_ASSOCIATION_SET: 256,
                      IP_CONFIGURATION_GET: 257,
                      IP_CONFIGURATION_RELEASE: 258,
                      IP_CONFIGURATION_RENEW: 259,
                      IP_CONFIGURATION_REPORT: 260,
                      IP_CONFIGURATION_SET: 261,
                      IRRIGATION_SYSTEM_CONFIG_GET: 262,
                      IRRIGATION_SYSTEM_CONFIG_REPORT: 263,
                      IRRIGATION_SYSTEM_CONFIG_SET: 264,
                      IRRIGATION_SYSTEM_INFO_GET: 265,
                      IRRIGATION_SYSTEM_INFO_REPORT: 266,
                      IRRIGATION_SYSTEM_SHUTOFF: 267,
                      IRRIGATION_SYSTEM_STATUS_GET: 268,
                      IRRIGATION_SYSTEM_STATUS_REPORT: 269,
                      IRRIGATION_VALVE_CONFIG_GET: 270,
                      IRRIGATION_VALVE_CONFIG_REPORT: 271,
                      IRRIGATION_VALVE_CONFIG_SET: 272,
                      IRRIGATION_VALVE_INFO_GET: 273,
                      IRRIGATION_VALVE_INFO_REPORT: 274,
                      IRRIGATION_VALVE_RUN: 275,
                      IRRIGATION_VALVE_TABLE_GET: 276,
                      IRRIGATION_VALVE_TABLE_REPORT: 277,
                      IRRIGATION_VALVE_TABLE_RUN: 278,
                      IRRIGATION_VALVE_TABLE_SET: 279,
                      KEX_FAIL: 280,
                      KEX_GET: 281,
                      KEX_REPORT: 282,
                      KEX_SET: 283,
                      LANGUAGE_GET: 284,
                      LANGUAGE_REPORT: 285,
                      LANGUAGE_SET: 286,
                      LAST_WORKING_ROUTE_GET: 287,
                      LAST_WORKING_ROUTE_REPORT: 288,
                      LAST_WORKING_ROUTE_SET: 289,
                      LEARN_MODE_SET: 290,
                      LEARN_MODE_SET_STATUS: 291,
                      LOCK_GET: 292,
                      LOCK_REPORT: 293,
                      LOCK_SET: 294,
                      LOST: 295,
                      LOWPAN_FIRST_FRAGMENT: 296,
                      LOWPAN_SUBSEQUENT_FRAGMENT: 297,
                      MAILBOX_CONFIGURATION_GET: 298,
                      MAILBOX_CONFIGURATION_REPORT: 299,
                      MAILBOX_CONFIGURATION_SET: 300,
                      MAILBOX_NODE_FAILING: 301,
                      MAILBOX_QUEUE: 302,
                      MAILBOX_WAKEUP_NOTIFICATION: 303,
                      MANUFACTURER_SPECIFIC_GET: 304,
                      MANUFACTURER_SPECIFIC_REPORT: 305,
                      METER_GET: 306,
                      METER_PULSE_GET: 307,
                      METER_PULSE_REPORT: 308,
                      METER_REPORT: 309,
                      METER_TBL_CURRENT_DATA_GET: 310,
                      METER_TBL_CURRENT_DATA_REPORT: 311,
                      METER_TBL_HISTORICAL_DATA_GET: 312,
                      METER_TBL_HISTORICAL_DATA_REPORT: 313,
                      METER_TBL_PUSH_CONFIGURATION_GET: 314,
                      METER_TBL_PUSH_CONFIGURATION_REPORT: 315,
                      METER_TBL_PUSH_CONFIGURATION_SET: 316,
                      METER_TBL_REPORT: 317,
                      METER_TBL_STATUS_DATE_GET: 318,
                      METER_TBL_STATUS_DEPTH_GET: 319,
                      METER_TBL_STATUS_REPORT: 320,
                      METER_TBL_STATUS_SUPPORTED_GET: 321,
                      METER_TBL_STATUS_SUPPORTED_REPORT: 322,
                      METER_TBL_TABLE_CAPABILITY_GET: 323,
                      METER_TBL_TABLE_ID_GET: 324,
                      METER_TBL_TABLE_ID_REPORT: 325,
                      METER_TBL_TABLE_POINT_ADM_NO_GET: 326,
                      METER_TBL_TABLE_POINT_ADM_NO_REPORT: 327,
                      METER_TBL_TABLE_POINT_ADM_NO_SET: 328,
                      MOVE_TO_POSITION_GET: 329,
                      MOVE_TO_POSITION_REPORT: 330,
                      MOVE_TO_POSITION_SET: 331,
                      MULTI_CHANNEL_ASSOCIATION_GET: 332,
                      MULTI_CHANNEL_ASSOCIATION_GROUPINGS_GET: 333,
                      MULTI_CHANNEL_ASSOCIATION_GROUPINGS_REPORT: 334,
                      MULTI_CHANNEL_ASSOCIATION_REMOVE: 335,
                      MULTI_CHANNEL_ASSOCIATION_REPORT: 336,
                      MULTI_CHANNEL_ASSOCIATION_SET: 337,
                      MULTI_CHANNEL_CAPABILITY_GET: 338,
                      MULTI_CHANNEL_CAPABILITY_REPORT: 339,
                      MULTI_CHANNEL_CMD_ENCAP: 340,
                      MULTI_CHANNEL_END_POINT_FIND: 341,
                      MULTI_CHANNEL_END_POINT_FIND_REPORT: 342,
                      MULTI_CHANNEL_END_POINT_GET: 343,
                      MULTI_CHANNEL_END_POINT_REPORT: 344,
                      MULTI_CMD_ENCAP: 345,
                      MULTI_INSTANCE_ASSOCIATION_GET: 346,
                      MULTI_INSTANCE_ASSOCIATION_GROUPINGS_GET: 347,
                      MULTI_INSTANCE_ASSOCIATION_GROUPINGS_REPORT: 348,
                      MULTI_INSTANCE_ASSOCIATION_REMOVE: 349,
                      MULTI_INSTANCE_ASSOCIATION_REPORT: 350,
                      MULTI_INSTANCE_ASSOCIATION_SET: 351,
                      MULTI_INSTANCE_CMD_ENCAP: 352,
                      MULTI_INSTANCE_GET: 353,
                      MULTI_INSTANCE_REPORT: 354,
                      NETWORK_KEY_SET: 355,
                      NETWORK_KEY_VERIFY: 356,
                      NETWORK_UPDATE_REQUEST: 357,
                      NETWORK_UPDATE_REQUEST_STATUS: 358,
                      NEW_NODE_REGISTERED: 359,
                      NEW_RANGE_REGISTERED: 360,
                      NODE_ADD: 361,
                      NODE_ADD_STATUS: 362,
                      NODE_INFO: 363,
                      NODE_INFORMATION_SEND: 364,
                      NODE_INFO_CACHED_GET: 365,
                      NODE_INFO_CACHED_REPORT: 366,
                      NODE_LIST_GET: 367,
                      NODE_LIST_REPORT: 368,
                      NODE_NAMING_NODE_LOCATION_GET: 369,
                      NODE_NAMING_NODE_LOCATION_REPORT: 370,
                      NODE_NAMING_NODE_LOCATION_SET: 371,
                      NODE_NAMING_NODE_NAME_GET: 372,
                      NODE_NAMING_NODE_NAME_REPORT: 373,
                      NODE_NAMING_NODE_NAME_SET: 374,
                      NODE_NEIGHBOR_UPDATE_REQUEST: 375,
                      NODE_NEIGHBOR_UPDATE_STATUS: 376,
                      NODE_RANGE_INFO: 377,
                      NODE_REMOVE: 378,
                      NODE_REMOVE_STATUS: 379,
                      NOTIFICATION_GET: 380,
                      NOTIFICATION_REPORT: 381,
                      NOTIFICATION_SET: 382,
                      NOTIFICATION_SUPPORTED_GET: 383,
                      NOTIFICATION_SUPPORTED_REPORT: 384,
                      POWERLEVEL_GET: 385,
                      POWERLEVEL_REPORT: 386,
                      POWERLEVEL_SET: 387,
                      POWERLEVEL_TEST_NODE_GET: 388,
                      POWERLEVEL_TEST_NODE_REPORT: 389,
                      POWERLEVEL_TEST_NODE_SET: 390,
                      PREPAYMENT_BALANCE_GET: 391,
                      PREPAYMENT_BALANCE_REPORT: 392,
                      PREPAYMENT_SUPPORTED_GET: 393,
                      PREPAYMENT_SUPPORTED_REPORT: 394,
                      PROPRIETARY_GET: 395,
                      PROPRIETARY_REPORT: 396,
                      PROPRIETARY_SET: 397,
                      PROTECTION_GET: 398,
                      PROTECTION_REPORT: 399,
                      PROTECTION_SET: 400,
                      PUBLIC_KEY_REPORT: 401,
                      RATE_TBL_ACTIVE_RATE_GET: 402,
                      RATE_TBL_ACTIVE_RATE_REPORT: 403,
                      RATE_TBL_CURRENT_DATA_GET: 404,
                      RATE_TBL_CURRENT_DATA_REPORT: 405,
                      RATE_TBL_GET: 406,
                      RATE_TBL_HISTORICAL_DATA_GET: 407,
                      RATE_TBL_HISTORICAL_DATA_REPORT: 408,
                      RATE_TBL_REMOVE: 409,
                      RATE_TBL_REPORT: 410,
                      RATE_TBL_SET: 411,
                      RATE_TBL_SUPPORTED_GET: 412,
                      RATE_TBL_SUPPORTED_REPORT: 413,
                      RECORD_GET: 414,
                      RECORD_REPORT: 415,
                      REMOTE_ASSOCIATION_ACTIVATE: 416,
                      REMOTE_ASSOCIATION_CONFIGURATION_GET: 417,
                      REMOTE_ASSOCIATION_CONFIGURATION_REPORT: 418,
                      REMOTE_ASSOCIATION_CONFIGURATION_SET: 419,
                      REQUEST_NODE_INFO: 420,
                      RETURN_ROUTE_ASSIGN: 421,
                      RETURN_ROUTE_ASSIGN_COMPLETE: 422,
                      RETURN_ROUTE_DELETE: 423,
                      RETURN_ROUTE_DELETE_COMPLETE: 424,
                      SCENE_ACTIVATION_SET: 425,
                      SCENE_ACTUATOR_CONF_GET: 426,
                      SCENE_ACTUATOR_CONF_REPORT: 427,
                      SCENE_ACTUATOR_CONF_SET: 428,
                      SCENE_CONTROLLER_CONF_GET: 429,
                      SCENE_CONTROLLER_CONF_REPORT: 430,
                      SCENE_CONTROLLER_CONF_SET: 431,
                      SCHEDULE_CHANGED_GET: 432,
                      SCHEDULE_CHANGED_REPORT: 433,
                      SCHEDULE_ENTRY_LOCK_ENABLE_ALL_SET: 434,
                      SCHEDULE_ENTRY_LOCK_ENABLE_SET: 435,
                      SCHEDULE_ENTRY_LOCK_WEEK_DAY_GET: 436,
                      SCHEDULE_ENTRY_LOCK_WEEK_DAY_REPORT: 437,
                      SCHEDULE_ENTRY_LOCK_WEEK_DAY_SET: 438,
                      SCHEDULE_ENTRY_LOCK_YEAR_DAY_GET: 439,
                      SCHEDULE_ENTRY_LOCK_YEAR_DAY_REPORT: 440,
                      SCHEDULE_ENTRY_LOCK_YEAR_DAY_SET: 441,
                      SCHEDULE_ENTRY_TYPE_SUPPORTED_GET: 442,
                      SCHEDULE_ENTRY_TYPE_SUPPORTED_REPORT: 443,
                      SCHEDULE_GET: 444,
                      SCHEDULE_OVERRIDE_GET: 445,
                      SCHEDULE_OVERRIDE_REPORT: 446,
                      SCHEDULE_OVERRIDE_SET: 447,
                      SCHEDULE_REMOVE: 448,
                      SCHEDULE_REPORT: 449,
                      SCHEDULE_SET: 450,
                      SCHEDULE_STATE_GET: 451,
                      SCHEDULE_STATE_REPORT: 452,
                      SCHEDULE_STATE_SET: 453,
                      SCHEDULE_SUPPORTED_GET: 454,
                      SCHEDULE_SUPPORTED_REPORT: 455,
                      SCREEN_ATTRIBUTES_GET: 456,
                      SCREEN_ATTRIBUTES_REPORT: 457,
                      SCREEN_MD_GET: 458,
                      SCREEN_MD_REPORT: 459,
                      SECURITY_2_CAPABILITIES_GET: 460,
                      SECURITY_2_CAPABILITIES_REPORT: 461,
                      SECURITY_2_COMMANDS_SUPPORTED_GET: 462,
                      SECURITY_2_COMMANDS_SUPPORTED_REPORT: 463,
                      SECURITY_2_MESSAGE_ENCAPSULATION: 464,
                      SECURITY_2_NETWORK_KEY_GET: 465,
                      SECURITY_2_NETWORK_KEY_REPORT: 466,
                      SECURITY_2_NETWORK_KEY_VERIFY: 467,
                      SECURITY_2_NONCE_GET: 468,
                      SECURITY_2_NONCE_REPORT: 469,
                      SECURITY_2_TRANSFER_END: 470,
                      SECURITY_COMMANDS_SUPPORTED_GET: 471,
                      SECURITY_COMMANDS_SUPPORTED_REPORT: 472,
                      SECURITY_MESSAGE_ENCAPSULATION: 473,
                      SECURITY_MESSAGE_ENCAPSULATION_NONCE_GET: 474,
                      SECURITY_NONCE_GET: 475,
                      SECURITY_NONCE_REPORT: 476,
                      SECURITY_PANEL_MODE_GET: 477,
                      SECURITY_PANEL_MODE_REPORT: 478,
                      SECURITY_PANEL_MODE_SET: 479,
                      SECURITY_PANEL_MODE_SUPPORTED_GET: 480,
                      SECURITY_PANEL_MODE_SUPPORTED_REPORT: 481,
                      SECURITY_PANEL_ZONE_NUMBER_SUPPORTED_GET: 482,
                      SECURITY_PANEL_ZONE_SENSOR_INSTALLED_GET: 483,
                      SECURITY_PANEL_ZONE_SENSOR_STATE_GET: 484,
                      SECURITY_PANEL_ZONE_SENSOR_STATE_REPORT: 485,
                      SECURITY_PANEL_ZONE_SENSOR_TYPE_GET: 486,
                      SECURITY_PANEL_ZONE_SENSOR_TYPE_REPORT: 487,
                      SECURITY_PANEL_ZONE_STATE_GET: 488,
                      SECURITY_PANEL_ZONE_STATE_REPORT: 489,
                      SECURITY_PANEL_ZONE_SUPPORTED_REPORT: 490,
                      SECURITY_PANEL_ZONE_TYPE_GET: 491,
                      SECURITY_PANEL_ZONE_TYPE_REPORT: 492,
                      SECURITY_SCHEME_GET: 493,
                      SECURITY_SCHEME_INHERIT: 494,
                      SECURITY_SCHEME_REPORT: 495,
                      SENSOR_ALARM_GET: 496,
                      SENSOR_ALARM_REPORT: 497,
                      SENSOR_ALARM_SET: 498,
                      SENSOR_ALARM_SUPPORTED_GET: 499,
                      SENSOR_ALARM_SUPPORTED_REPORT: 500,
                      SENSOR_BINARY_GET: 501,
                      SENSOR_BINARY_REPORT: 502,
                      SENSOR_MULTILEVEL_GET: 503,
                      SENSOR_MULTILEVEL_REPORT: 504,
                      SENSOR_TRIGGER_LEVEL_GET: 505,
                      SENSOR_TRIGGER_LEVEL_REPORT: 506,
                      SENSOR_TRIGGER_LEVEL_SET: 507,
                      SIMPLE_AV_CONTROL_GET: 508,
                      SIMPLE_AV_CONTROL_REPORT: 509,
                      SIMPLE_AV_CONTROL_SET: 510,
                      SIMPLE_AV_CONTROL_SUPPORTED_GET: 511,
                      SIMPLE_AV_CONTROL_SUPPORTED_REPORT: 512,
                      STATISTICS_CLEAR: 513,
                      STATISTICS_GET: 514,
                      STATISTICS_REPORT: 515,
                      SUPERVISION_GET: 516,
                      SUPERVISION_REPORT: 517,
                      SWITCH_ALL_GET: 518,
                      SWITCH_ALL_OFF: 519,
                      SWITCH_ALL_ON: 520,
                      SWITCH_ALL_REPORT: 521,
                      SWITCH_ALL_SET: 522,
                      SWITCH_BINARY_GET: 523,
                      SWITCH_BINARY_REPORT: 524,
                      SWITCH_BINARY_SET: 525,
                      SWITCH_COLOR_GET: 526,
                      SWITCH_COLOR_REPORT: 527,
                      SWITCH_COLOR_SET: 528,
                      SWITCH_COLOR_START_LEVEL_CHANGE: 529,
                      SWITCH_COLOR_STOP_LEVEL_CHANGE: 530,
                      SWITCH_COLOR_SUPPORTED_GET: 531,
                      SWITCH_COLOR_SUPPORTED_REPORT: 532,
                      SWITCH_MULTILEVEL_GET: 533,
                      SWITCH_MULTILEVEL_REPORT: 534,
                      SWITCH_MULTILEVEL_SET: 535,
                      SWITCH_MULTILEVEL_START_LEVEL_CHANGE: 536,
                      SWITCH_MULTILEVEL_STOP_LEVEL_CHANGE: 537,
                      SWITCH_TOGGLE_BINARY_GET: 538,
                      SWITCH_TOGGLE_BINARY_REPORT: 539,
                      SWITCH_TOGGLE_BINARY_SET: 540,
                      SWITCH_TOGGLE_MULTILEVEL_GET: 541,
                      SWITCH_TOGGLE_MULTILEVEL_REPORT: 542,
                      SWITCH_TOGGLE_MULTILEVEL_SET: 543,
                      SWITCH_TOGGLE_MULTILEVEL_START_LEVEL_CHANGE: 544,
                      SWITCH_TOGGLE_MULTILEVEL_STOP_LEVEL_CHANGE: 545,
                      TARIFF_TBL_COST_GET: 546,
                      TARIFF_TBL_COST_REPORT: 547,
                      TARIFF_TBL_GET: 548,
                      TARIFF_TBL_REMOVE: 549,
                      TARIFF_TBL_REPORT: 550,
                      TARIFF_TBL_SET: 551,
                      TARIFF_TBL_SUPPLIER_GET: 552,
                      TARIFF_TBL_SUPPLIER_REPORT: 553,
                      TARIFF_TBL_SUPPLIER_SET: 554,
                      THERMOSTAT_FAN_MODE_GET: 555,
                      THERMOSTAT_FAN_MODE_REPORT: 556,
                      THERMOSTAT_FAN_MODE_SET: 557,
                      THERMOSTAT_FAN_MODE_SUPPORTED_GET: 558,
                      THERMOSTAT_FAN_MODE_SUPPORTED_REPORT: 559,
                      THERMOSTAT_FAN_STATE_GET: 560,
                      THERMOSTAT_FAN_STATE_REPORT: 561,
                      THERMOSTAT_HEATING_MODE_GET: 562,
                      THERMOSTAT_HEATING_MODE_REPORT: 563,
                      THERMOSTAT_HEATING_MODE_SET: 564,
                      THERMOSTAT_HEATING_RELAY_STATUS_GET: 565,
                      THERMOSTAT_HEATING_RELAY_STATUS_REPORT: 566,
                      THERMOSTAT_HEATING_SETPOINT_GET: 567,
                      THERMOSTAT_HEATING_SETPOINT_REPORT: 568,
                      THERMOSTAT_HEATING_SETPOINT_SET: 569,
                      THERMOSTAT_HEATING_STATUS_GET: 570,
                      THERMOSTAT_HEATING_STATUS_REPORT: 571,
                      THERMOSTAT_HEATING_STATUS_SET: 572,
                      THERMOSTAT_HEATING_TIMED_OFF_SET: 573,
                      THERMOSTAT_MODE_GET: 574,
                      THERMOSTAT_MODE_REPORT: 575,
                      THERMOSTAT_MODE_SET: 576,
                      THERMOSTAT_MODE_SUPPORTED_GET: 577,
                      THERMOSTAT_MODE_SUPPORTED_REPORT: 578,
                      THERMOSTAT_OPERATING_STATE_GET: 579,
                      THERMOSTAT_OPERATING_STATE_REPORT: 580,
                      THERMOSTAT_SETBACK_GET: 581,
                      THERMOSTAT_SETBACK_REPORT: 582,
                      THERMOSTAT_SETBACK_SET: 583,
                      THERMOSTAT_SETPOINT_GET: 584,
                      THERMOSTAT_SETPOINT_REPORT: 585,
                      THERMOSTAT_SETPOINT_SET: 586,
                      THERMOSTAT_SETPOINT_SUPPORTED_GET: 587,
                      THERMOSTAT_SETPOINT_SUPPORTED_REPORT: 588,
                      TIME_GET: 589,
                      TIME_PARAMETERS_GET: 590,
                      TIME_PARAMETERS_REPORT: 591,
                      TIME_PARAMETERS_SET: 592,
                      TIME_REPORT: 593,
                      TRANSFER_END: 594,
                      TRANSFER_NEW_PRIMARY_COMPLETE: 595,
                      TRANSFER_NODE_INFO: 596,
                      TRANSFER_PRESENTATION: 597,
                      TRANSFER_RANGE_INFO: 598,
                      UNSOLICITED_DESTINATION_GET: 599,
                      UNSOLICITED_DESTINATION_REPORT: 600,
                      UNSOLICITED_DESTINATION_SET: 601,
                      USERS_NUMBER_GET: 602,
                      USERS_NUMBER_REPORT: 603,
                      USER_CODE_GET: 604,
                      USER_CODE_REPORT: 605,
                      USER_CODE_SET: 606,
                      VERSION_COMMAND_CLASS_GET: 607,
                      VERSION_COMMAND_CLASS_REPORT: 608,
                      VERSION_GET: 609,
                      VERSION_REPORT: 610,
                      WAKE_UP_INTERVAL_GET: 611,
                      WAKE_UP_INTERVAL_REPORT: 612,
                      WAKE_UP_INTERVAL_SET: 613,
                      WAKE_UP_NOTIFICATION: 614,
                      WAKE_UP_NO_MORE_INFORMATION: 615,
                      WINDOW_COVERING_GET: 616,
                      WINDOW_COVERING_REPORT: 617,
                      WINDOW_COVERING_SET: 618,
                      WINDOW_COVERING_START_LEVEL_CHANGE: 619,
                      WINDOW_COVERING_STOP_LEVEL_CHANGE: 620,
                      WINDOW_COVERING_SUPPORTED_GET: 621,
                      WINDOW_COVERING_SUPPORTED_REPORT: 622,
                      ZIP_INV_NODE_SOLICITATION: 623,
                      ZIP_NAMING_LOCATION_GET: 624,
                      ZIP_NAMING_LOCATION_REPORT: 625,
                      ZIP_NAMING_LOCATION_SET: 626,
                      ZIP_NAMING_NAME_GET: 627,
                      ZIP_NAMING_NAME_REPORT: 628,
                      ZIP_NAMING_NAME_SET: 629,
                      ZIP_NODE_ADVERTISEMENT: 630,
                      ZIP_NODE_SOLICITATION: 631,
                      ZWAVEPLUS_INFO_GET: 632,
                      ZWAVEPLUS_INFO_REPORT: 633,
                      ZWAVE_CMD_NOP: 634,
                      ZWAVE_CMD_RESERVE_NODE_IDS: 635
                    }
                  },
                  ZigBeeMsg: {
                    fields: {
                      type: {
                        type: "ZigBeeCmdType",
                        id: 1
                      },
                      zclCmd: {
                        type: "ZCLCmd",
                        id: 2
                      },
                      networkMgmtCmd: {
                        type: "NetworkMgmtCmd",
                        id: 3
                      }
                    },
                    nested: {
                      ZigBeeCmdType: {
                        values: {
                          ZCL: 0,
                          NETWORK_MGMT: 1
                        }
                      },
                      ZCLCmd: {
                        fields: {
                          type: {
                            type: "ZCLCmdType",
                            id: 1
                          },
                          onoffCmd: {
                            type: "OnOffCmd",
                            id: 2
                          },
                          levelCmd: {
                            type: "LevelCmd",
                            id: 3
                          },
                          colorcontrolCmd: {
                            type: "ColorControlCmd",
                            id: 4
                          },
                          identifyCmd: {
                            type: "IdentifyCmd",
                            id: 5
                          },
                          nodeId: {
                            type: "uint32",
                            id: 6
                          },
                          endpointIndex: {
                            type: "uint32",
                            id: 7
                          }
                        },
                        nested: {
                          ZCLCmdType: {
                            values: {
                              ON_OFF: 0,
                              LEVEL: 1,
                              COLOR_CONTROL: 2,
                              IDENTIFY: 3
                            }
                          },
                          OnOffCmd: {
                            fields: {
                              type: {
                                type: "ZCLOnOffCmdType",
                                id: 1
                              }
                            },
                            nested: {
                              ZCLOnOffCmdType: {
                                values: {
                                  ON: 0,
                                  OFF: 1,
                                  TOGGLE: 2
                                }
                              }
                            }
                          },
                          LevelCmd: {
                            fields: {
                              type: {
                                type: "ZCLLevelCmdType",
                                id: 1
                              },
                              moveToLevelParams: {
                                type: "MoveToLevelCmdParams",
                                id: 2
                              },
                              moveParams: {
                                type: "MoveCmdParams",
                                id: 3
                              }
                            },
                            nested: {
                              ZCLLevelCmdType: {
                                values: {
                                  MOVE_TO_LEVEL: 0,
                                  MOVE: 1
                                }
                              },
                              MoveToLevelCmdParams: {
                                fields: {
                                  level: {
                                    type: "uint32",
                                    id: 1
                                  },
                                  transitionTime: {
                                    type: "uint32",
                                    id: 2
                                  }
                                }
                              },
                              MoveCmdParams: {
                                fields: {
                                  mode: {
                                    type: "uint32",
                                    id: 1
                                  },
                                  rate: {
                                    type: "uint32",
                                    id: 2
                                  }
                                }
                              }
                            }
                          },
                          ColorControlCmd: {
                            fields: {
                              type: {
                                type: "ZCLColorControlCmdType",
                                id: 1
                              },
                              movetohueParams: {
                                type: "MoveToHueCmdParams",
                                id: 2
                              },
                              movetosatParams: {
                                type: "MoveToSatCmdParams",
                                id: 3
                              },
                              movetohueandsatParams: {
                                type: "MoveToHueAndSatCmdParams",
                                id: 4
                              }
                            },
                            nested: {
                              ZCLColorControlCmdType: {
                                values: {
                                  MOVETOHUE: 0,
                                  MOVETOSAT: 1,
                                  MOVETOHUEANDSAT: 2
                                }
                              },
                              MoveToHueCmdParams: {
                                fields: {
                                  hue: {
                                    type: "uint32",
                                    id: 1
                                  },
                                  direction: {
                                    type: "DirectionParam",
                                    id: 2
                                  },
                                  transitionTime: {
                                    type: "uint32",
                                    id: 3
                                  }
                                },
                                nested: {
                                  DirectionParam: {
                                    values: {
                                      SHORTEST_DISTANCE: 0,
                                      LONGEST_DISTANCE: 1,
                                      UP: 2,
                                      DOWN: 3
                                    }
                                  }
                                }
                              },
                              MoveToSatCmdParams: {
                                fields: {
                                  saturation: {
                                    type: "uint32",
                                    id: 1
                                  },
                                  transitionTime: {
                                    type: "uint32",
                                    id: 2
                                  }
                                }
                              },
                              MoveToHueAndSatCmdParams: {
                                fields: {
                                  hue: {
                                    type: "uint32",
                                    id: 1
                                  },
                                  saturation: {
                                    type: "uint32",
                                    id: 2
                                  },
                                  transitionTime: {
                                    type: "uint32",
                                    id: 3
                                  }
                                }
                              }
                            }
                          },
                          IdentifyCmd: {
                            fields: {
                              type: {
                                type: "ZCLIdentifyCmdType",
                                id: 1
                              },
                              identifyOnParams: {
                                type: "IdentifyOnCmdParams",
                                id: 2
                              },
                              identifyOffParams: {
                                type: "IdentifyOffCmdParams",
                                id: 3
                              }
                            },
                            nested: {
                              ZCLIdentifyCmdType: {
                                values: {
                                  IDENTIFY_ON: 0,
                                  IDENTIFY_OFF: 1
                                }
                              },
                              IdentifyOnCmdParams: {
                                fields: {
                                  endpoint: {
                                    type: "uint32",
                                    id: 1
                                  },
                                  identifyTime: {
                                    type: "uint32",
                                    id: 2
                                  }
                                }
                              },
                              IdentifyOffCmdParams: {
                                fields: {
                                  identifyTime: {
                                    type: "uint32",
                                    id: 1
                                  }
                                }
                              }
                            }
                          }
                        }
                      },
                      NetworkMgmtCmd: {
                        fields: {
                          type: {
                            type: "NetworkMgmtCmdTypes",
                            id: 1
                          },
                          permitJoinParams: {
                            type: "PermitJoinParams",
                            id: 2
                          },
                          isProxyActive: {
                            type: "bool",
                            id: 3
                          },
                          nodeLeaveParams: {
                            type: "NodeLeaveNetParams",
                            id: 4
                          },
                          nodeInfo: {
                            type: "NodeDescription",
                            id: 5
                          },
                          connectedNodes: {
                            rule: "repeated",
                            type: "NodeDescription",
                            id: 6
                          },
                          networkStatus: {
                            type: "NetworkStatus",
                            id: 7
                          }
                        },
                        nested: {
                          NetworkMgmtCmdTypes: {
                            values: {
                              CREATE_NWK: 0,
                              LEAVE_NWK: 1,
                              NODE_LEAVE_NWK: 2,
                              PERMIT_JOIN: 3,
                              DISCOVERY_INFO: 4,
                              RESET_PROXY: 5,
                              IS_PROXY_ACTIVE: 6,
                              NETWORK_STATUS: 7
                            }
                          },
                          PermitJoinParams: {
                            fields: {
                              time: {
                                type: "uint32",
                                id: 1
                              }
                            }
                          },
                          NodeLeaveNetParams: {
                            fields: {
                              nodeId: {
                                type: "uint32",
                                id: 1
                              }
                            }
                          },
                          ClusterDescription: {
                            fields: {
                              type: {
                                type: "ClusterInOutType",
                                id: 1
                              },
                              clusterId: {
                                type: "uint32",
                                id: 2
                              }
                            },
                            nested: {
                              ClusterInOutType: {
                                values: {
                                  SERVER_IN: 0,
                                  CLIENT_OUT: 1
                                }
                              }
                            }
                          },
                          EndPointDescription: {
                            fields: {
                              endpointIndex: {
                                type: "uint32",
                                id: 1
                              },
                              profileId: {
                                type: "uint32",
                                id: 2
                              },
                              deviceId: {
                                type: "uint32",
                                id: 3
                              },
                              clusters: {
                                rule: "repeated",
                                type: "ClusterDescription",
                                id: 4
                              }
                            }
                          },
                          NodeDescription: {
                            fields: {
                              nodeId: {
                                type: "uint32",
                                id: 1
                              },
                              eui64: {
                                type: "uint64",
                                id: 2
                              },
                              endpoints: {
                                rule: "repeated",
                                type: "EndPointDescription",
                                id: 3
                              }
                            }
                          },
                          NetworkStatus: {
                            fields: {
                              type: {
                                type: "Status",
                                id: 1
                              }
                            },
                            nested: {
                              Status: {
                                values: {
                                  NO_NETWORK: 0,
                                  JOINING_NETWORK: 1,
                                  JOINED_NETWORK: 2,
                                  JOINED_NETWORK_NO_PARENT: 3,
                                  LEAVING_NETWORK: 4
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  },
                  ZWaveMsg: {
                    fields: {
                      operation: {
                        type: "ZWaveOperations",
                        id: 1
                      },
                      serviceToSend: {
                        type: "string",
                        id: 2
                      },
                      zwaveCmd: {
                        type: "ZWaveCommand",
                        id: 3
                      },
                      node: {
                        rule: "repeated",
                        type: "ZWaveNode",
                        id: 4
                      },
                      result: {
                        type: "bool",
                        id: 5
                      }
                    },
                    nested: {
                      ZWaveOperations: {
                        values: {
                          UNDEF: 0,
                          SEND: 1,
                          ADDNODE: 2,
                          REMOVENODE: 3,
                          SETDEFAULT: 4,
                          LIST: 5
                        }
                      },
                      ZWaveCommandInfo: {
                        fields: {
                          cmd: {
                            type: "matrix_io.malos.v1.comm.ZWaveCmdType",
                            id: 1
                          },
                          param: {
                            rule: "repeated",
                            type: "string",
                            id: 2
                          }
                        }
                      },
                      ZWaveClassInfo: {
                        fields: {
                          zwaveClass: {
                            type: "matrix_io.malos.v1.comm.ZWaveClassType",
                            id: 1
                          },
                          command: {
                            rule: "repeated",
                            type: "ZWaveCommandInfo",
                            id: 2
                          }
                        }
                      },
                      ZWaveNode: {
                        fields: {
                          serviceName: {
                            type: "string",
                            id: 1
                          },
                          zwaveClass: {
                            rule: "repeated",
                            type: "ZWaveClassInfo",
                            id: 2
                          }
                        }
                      },
                      ZWaveCommand: {
                        fields: {
                          zwclass: {
                            type: "matrix_io.malos.v1.comm.ZWaveClassType",
                            id: 1
                          },
                          cmd: {
                            type: "matrix_io.malos.v1.comm.ZWaveCmdType",
                            id: 2
                          },
                          params: {
                            type: "bytes",
                            id: 3
                          }
                        }
                      }
                    }
                  },
                  LircParams: {
                    fields: {
                      device: {
                        type: "string",
                        id: 1
                      },
                      command: {
                        type: "string",
                        id: 2
                      },
                      config: {
                        type: "string",
                        id: 3
                      }
                    }
                  }
                }
              },
              driver: {
                options: {
                  csharp_namespace: "MatrixIO.Malos.Driver.V1",
                  java_multiple_files: true,
                  java_outer_classname: "DriverProto",
                  java_package: "one.matrixio.proto.malos.v1"
                },
                nested: {
                  DriverConfig: {
                    fields: {
                      delayBetweenUpdates: {
                        type: "float",
                        id: 1
                      },
                      timeoutAfterLastPing: {
                        type: "float",
                        id: 2
                      },
                      image: {
                        type: "matrix_io.malos.v1.io.EverloopImage",
                        id: 3
                      },
                      malosEyeConfig: {
                        type: "matrix_io.malos.v1.maloseye.MalosEyeConfig",
                        id: 4
                      },
                      zigbeeMessage: {
                        type: "matrix_io.malos.v1.comm.ZigBeeMsg",
                        id: 5
                      },
                      lirc: {
                        type: "matrix_io.malos.v1.comm.LircParams",
                        id: 6
                      },
                      servo: {
                        type: "matrix_io.malos.v1.io.ServoParams",
                        id: 7
                      },
                      gpio: {
                        type: "matrix_io.malos.v1.io.GpioParams",
                        id: 8
                      },
                      humidity: {
                        type: "matrix_io.malos.v1.sense.HumidityParams",
                        id: 9
                      },
                      micarray: {
                        type: "matrix_io.malos.v1.io.MicArrayParams",
                        id: 10
                      },
                      zwave: {
                        type: "matrix_io.malos.v1.comm.ZWaveMsg",
                        id: 11
                      },
                      wakeword: {
                        type: "matrix_io.malos.v1.io.WakeWordParams",
                        id: 12
                      }
                    }
                  },
                  DriverInfo: {
                    fields: {
                      driverName: {
                        type: "string",
                        id: 1
                      },
                      basePort: {
                        type: "int32",
                        id: 2
                      },
                      providesUpdates: {
                        type: "bool",
                        id: 3
                      },
                      delayBetweenUpdates: {
                        type: "int32",
                        id: 4
                      },
                      needsPings: {
                        type: "bool",
                        id: 5
                      },
                      timeoutAfterLastPing: {
                        type: "int32",
                        id: 6
                      },
                      notesForHuman: {
                        type: "string",
                        id: 7
                      }
                    }
                  },
                  MalosDriverInfo: {
                    fields: {
                      info: {
                        rule: "repeated",
                        type: "DriverInfo",
                        id: 1
                      }
                    }
                  }
                }
              },
              sense: {
                options: {
                  csharp_namespace: "MatrixIO.Malos.Sense.V1",
                  java_multiple_files: true,
                  java_outer_classname: "SenseProto",
                  java_package: "one.matrixio.proto.malos.v1"
                },
                nested: {
                  Dummy: {
                    fields: {
                      value: {
                        type: "float",
                        id: 1
                      }
                    }
                  },
                  Humidity: {
                    fields: {
                      humidity: {
                        type: "float",
                        id: 1
                      },
                      temperature: {
                        type: "float",
                        id: 2
                      },
                      temperatureRaw: {
                        type: "float",
                        id: 3
                      },
                      temperatureIsCalibrated: {
                        type: "bool",
                        id: 4
                      }
                    }
                  },
                  HumidityParams: {
                    fields: {
                      currentTemperature: {
                        type: "float",
                        id: 1
                      }
                    }
                  },
                  UV: {
                    fields: {
                      uvIndex: {
                        type: "float",
                        id: 1
                      },
                      omsRisk: {
                        type: "string",
                        id: 2
                      }
                    }
                  },
                  Pressure: {
                    fields: {
                      pressure: {
                        type: "float",
                        id: 1
                      },
                      altitude: {
                        type: "float",
                        id: 2
                      },
                      temperature: {
                        type: "float",
                        id: 3
                      }
                    }
                  },
                  Imu: {
                    fields: {
                      yaw: {
                        type: "float",
                        id: 1
                      },
                      pitch: {
                        type: "float",
                        id: 2
                      },
                      roll: {
                        type: "float",
                        id: 3
                      },
                      accelX: {
                        type: "float",
                        id: 4
                      },
                      accelY: {
                        type: "float",
                        id: 5
                      },
                      accelZ: {
                        type: "float",
                        id: 6
                      },
                      gyroX: {
                        type: "float",
                        id: 7
                      },
                      gyroY: {
                        type: "float",
                        id: 8
                      },
                      gyroZ: {
                        type: "float",
                        id: 9
                      },
                      magX: {
                        type: "float",
                        id: 10
                      },
                      magY: {
                        type: "float",
                        id: 11
                      },
                      magZ: {
                        type: "float",
                        id: 12
                      }
                    }
                  }
                }
              },
              maloseye: {
                options: {
                  csharp_namespace: "MatrixIO.Malos.MalosEye.V1",
                  java_multiple_files: true,
                  java_outer_classname: "MalosEyeProto",
                  java_package: "one.matrixio.proto.malos.v1"
                },
                nested: {
                  MalosEyeConfig: {
                    fields: {
                      cameraConfig: {
                        type: "CameraConfig",
                        id: 1
                      },
                      detectionServerConfig: {
                        type: "DetectionServerConfig",
                        id: 4
                      },
                      objectToDetect: {
                        rule: "repeated",
                        type: "EnumMalosEyeDetectionType",
                        id: 21
                      }
                    }
                  },
                  CameraConfig: {
                    fields: {
                      source: {
                        type: "string",
                        id: 4
                      },
                      cameraId: {
                        type: "int32",
                        id: 1
                      },
                      width: {
                        type: "int32",
                        id: 2
                      },
                      height: {
                        type: "int32",
                        id: 3
                      }
                    }
                  },
                  DetectionServerConfig: {
                    fields: {
                      detectionServerAddress: {
                        type: "string",
                        id: 1
                      },
                      detectionServerTimeout: {
                        type: "int32",
                        id: 2
                      }
                    }
                  },
                  EnumMalosEyeDetectionType: {
                    values: {
                      STOP: 0,
                      FACE: 20,
                      FACE_DEMOGRAPHICS: 21,
                      FACE_DESCRIPTOR: 30,
                      HAND_THUMB_UP: 40,
                      HAND_PALM: 41,
                      HAND_PINCH: 42,
                      HAND_FIST: 43
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  },
  google: {
    nested: {
      protobuf: {
        nested: {
          Timestamp: {
            fields: {
              seconds: {
                type: "int64",
                id: 1
              },
              nanos: {
                type: "int32",
                id: 2
              }
            }
          }
        }
      }
    }
  }
});

module.exports = $root;
